//	Dan's Color Converter - class definition header file
//	
//	Copyright 1993 by Daniel Lyke
//
//
//	This is EgoWare. You may freely copy and distribute these programs as long
//	as all parts are distributed together and unaltered. All source code may be
//	incorporated into your own programs, but I'd appreciate it if you drop me a
//	postcard or message telling me that you're using it and what you're using
//	it for. I make no warranties, express or implied, concerning the proper
//	operation of the program or any of the accompanying source code.

#ifndef __DL_COLOR_H__
#define __DL_COLOR_H__


#define CTRL_SOURCETYPE 100
#define CTRL_TARGETTYPE 200


#define CTRL_SOURCECOLOR1	300
#define CTRL_SOURCECOLOR2	301
#define CTRL_SOURCECOLOR3	302

#define CTRL_TARGETCOLOR1	303
#define CTRL_TARGETCOLOR2	304
#define CTRL_TARGETCOLOR3	305

#define CTRL_SOURCESCALE1		306
#define CTRL_SOURCESCALE100	307
#define CTRL_SOURCESCALE255	308
#define CTRL_TARGETSCALE1		309
#define CTRL_TARGETSCALE100	310
#define CTRL_TARGETSCALE255	311


#define CTRL_SOURCEANGLEDEFAULT	312
#define CTRL_SOURCEANGLERADIANS	313
#define CTRL_SOURCEANGLEDEGREES	314

#define CTRL_TARGETANGLEDEFAULT	315
#define CTRL_TARGETANGLERADIANS	316
#define CTRL_TARGETANGLEDEGREES	317

#define CTRL_SOURCETEXT1	320
#define CTRL_SOURCETEXT2	321
#define CTRL_SOURCETEXT3	322

#define CTRL_TARGETTEXT1	323
#define CTRL_TARGETTEXT2	324
#define CTRL_TARGETTEXT3	325

#define CTRL_HELP		333

#define COLORTYPE_RGB 0
#define COLORTYPE_CMY 1
#define COLORTYPE_HLS 2
#define COLORTYPE_HSV 3
#define COLORTYPE_YIQ 4
#define COLORTYPE_YUV 5

#define HUE_UNDEFINED -1.0



class TBigColor
{
	private :
		double mdRed;
		double mdGreen;
		double mdBlue;
		double SetHLSValue(double dM1, double dM2, double dHue);

	public :
		void GetRGB(double &dRed, double &dGreen, double &dBlue);
		void SetRGB(double dRed, double dGreen, double dBlue);
		void GetCMY(double &dCyan, double &dMagenta, double &dYellow);
		void SetCMY(double dCyan, double dMagenta, double dYellow);
		void GetHLS(double &dHue, double &dLuminance, double &dSaturation);
		void SetHLS(double dHue, double dLuminance, double dSaturation);
		void GetHSV(double &dHue, double &dSaturation, double &dValue);
		void SetHSV(double dHue, double dSaturation, double dValue);
		void GetYIQ(double &dHue, double &dSaturation, double &dValue);
		void SetYIQ(double dHue, double dSaturation, double dValue);
		void GetYUV(double &dHue, double &dSaturation, double &dValue);
		void SetYUV(double dHue, double dSaturation, double dValue);
		void Get(int iType, double &d1, double &d2, double &d3);
		void Set(int iType, double d1, double d2, double d3);

}; // end of class TBigColor

#endif // ndef __DL_COLOR_H__
